/*
title:		AutoRotateUVW.ms
path:		$scripts\AShimScripts\scripts
autor:		AShim (Titov Mykhaylo)
e-mail:		ashim@rambler.ru
date:		february 2010
version:	1.0
*/

(
	include "$scripts/AShimScripts/functions/uvw.ms"
	
	global AShim_AutoRotateUVW
	fn AShim_AutoRotateUVW = (
		store_selected_vertices = #()
		store_selected_faces = #()
		elements = #()
		selected_objects = $selection as Array
		if (selected_objects.count < 1) do return undefined
		for obj in selected_objects do (
			if ((UVW = AShim_getUVWmodifier obj) != undefined) then (
				append store_selected_vertices (UVW.getSelectedVerticesByNode obj)
				append store_selected_faces (UVW.getSelectedFacesByNode obj)
				append elements (AShim_getUVWElementsSelectionFromFaces obj)
			)
			else (
				append undefined
				append undefined
				append undefined
			)
		)
		for obj in selected_objects do (
			if ((UVW = AShim_getUVWmodifier obj) != undefined) do (
				UVW.selectVerticesByNode #{} obj
				UVW.selectFacesByNode #{} obj
			)
		)
		for i = 1 to selected_objects.count do (
			obj = selected_objects[i]
			if (((UVW = AShim_getUVWmodifier obj) != undefined) AND (elements[i] != undefined)) then (
				for el in elements[i] do (
					UVW.selectFacesByNode el[1] obj
					UVW.faceToVertSelect()
					selected_vertices = UVW.getSelectedVerticesByNode obj
					border = AShim_getUVWBorder obj selected_vertices
					ABC = (AShim_findMinAreaDirection obj border)[1]
					angl = -atan (ABC[2] / ABC[1])
					UVW.selectFacesByNode el[2] obj
					UVW.rotateSelectedCenter (angl / 180 * PI)
					UVW.selectFacesByNode #{} obj
				)
			)
		)
		for i = 1 to selected_objects.count do (
			obj = selected_objects[i]
			if ((UVW = AShim_getUVWmodifier obj) != undefined) do (
				UVW.selectVerticesByNode store_selected_vertices[i] obj
				UVW.selectFacesByNode store_selected_faces[i] obj
			)
		)
	)
)