rollout AShim_rollout_setup "Setup AshimScripts v1.0" (
	local setup_result
	
	group "AShimScripts includes:" (
		label l_AutoRotateUVW "AutoRotateUVW v1.0" align:#left
	)
	label l_about_1 "Create by" align:#left across:3
	hyperLink  hl_mailto "AShim" address:"mailto:ashim@rambler.ru" align:#center offset:[-17,0]
	label l_about_2 "(Mykhaylo Titov)" align:#right across:3
	button bn_install "Install" width:95 across:2 offset:[-5,0]
	button bn_uninstall "Uninstall" width:95 offset:[5,0]
	progressBar pb_Progress width:192 offset:[-9,0]
	button bn_setup_msg "?" height:13 align:#left offset:[-9,0] across:2 visible:false
	label l_status "Select action..." align:#right
	
	fn AShim_IsInstall = (
		count = 0
		script_dir = getDirectories "$scripts/AShimScripts"
		for sd in (script_dir) do
			count += (getFiles (sd + "*.*")).count
		count += (getFiles "$usermacros/AShimScripts.mcr").count
		count != 0
	)

	fn AShim_install = (
		script_dir = getDirectories "AShimScripts/*.*"
		files = #()
		for sd in script_dir do (
			is_ok = makeDir ("$scripts/" + sd)
			if (NOt is_ok) do return 1
			files += getFiles (sd + "*.*")
		)
		files_count = files.count
		if (files_count != 3) do return 2
		for i = 1 to files_count do (
			is_ok = copyFile files[i] ("$scripts/" + files[i])
			if (NOt is_ok) do return 3
			pb_Progress.value = (100.0 * (i as Float) / ((files_count + 1) as Float)) as Integer
		)
		is_ok = copyFile "AShimScripts.mcr" "$usermacros/AShimScripts.mcr"
		if (NOt is_ok) do return 3
		AShim_rollout_setup.pb_Progress.value = 100
		0
	)

	fn AShim_deleteDirectory directory_name = (
		HiddenDOSCommand ("rd \"" + directory_name + "\"") donotwait:true 
	)

	fn AShim_uninstall = (
		result = 0
		script_dir = getDirectories "$scripts/AShimScripts/*.*"
		files = #()
		for sd in script_dir do (
			files += getFiles (sd + "*.*")
		)
		files_count = files.count
		if (files_count > 0) do(
			for i = 1 to files_count do (
				is_ok = deleteFile files[i]
				if (NOt is_ok) do result = 1
				pb_Progress.value = (100.0 * (i as Float) / ((files.count + 1) as Float)) as Integer
			)
		)
		for sd in script_dir do (
			AShim_deleteDirectory sd
		)
		AShim_deleteDirectory ((getDir #scripts) + "\\AShimScripts")
		if (((getFiles "$usermacros/AShimScripts.mcr").count != 0) AND NOT (deleteFile "$usermacros/AShimScripts.mcr")) do result += 2
		AShim_rollout_setup.pb_Progress.value = 100
		result
	)
	
	on AShim_rollout_setup open do (
		sysInfo.currentdir = "$temp"
		AShim_numfiles = 3
	)
	
	on bn_install pressed do (
		bn_setup_msg.visible = false
		l_status.caption = "Please wait. Installing..."
		if AShim_IsInstall() do (
			l_status.caption = "AShimScripts is installed."
			return false
		)
		setup_result = AShim_install()
		case (setup_result) of (
			0: l_status.caption = "AShimScripts has been installed."
			1: l_status.caption = "Error: Can't create folders."
			2: l_status.caption = "Error: Package is broken."
			3: l_status.caption = "Error: Can't copy files."
		)
		if (setup_result == 0) then (
			bn_setup_msg.visible = true
			fileIn "$usermacros/AShimScripts.mcr"
		)
		else (
			pb_Progress.value = 0
		)
	)
	
	on bn_uninstall pressed do (
		bn_setup_msg.visible = false
		setup_result = AShim_uninstall()
		if (setup_result == 0) then (
			l_status.caption = "AShimScripts has been uninstalled."
		)
		else (
			l_status.caption = "Can't uninstall AShimScripts."
			bn_setup_msg.visible = true
			pb_Progress.value = 0
		)
	)
	
	on bn_setup_msg pressed do (
		msg_1 = (getDir #scripts) + "\\AShimScripts"
		msg_2 = (getDir #usermacros) + "\\AShimScripts.mcr"
		case setup_result of (
			0: msg = "Using AShimScripts:\n1. open [Customize]>[Customize User Interface...]\n" + \
				"2. add to Keyboard/Toolbars/Quads/Menus necessary Action\n" + \
				"(Group: \"Main UI\" Category: \"AShimScripts\")\n" + \
				"3. enjoy :)"
			1: msg = "Can't delete: \n" + msg_1
			2: msg = "Can't delete: \n" + msg_2
			3: msg = "Can't delete: \n" + msg_1 + "\nand\n" + msg_2
		)
		messageBox (msg)
	)
	
	on AShim_rollout_setup close do (
		dir_array = GetDirectories ("$temp/AShimScripts/*")
		for d in dir_array do (
			join dir_array (GetDirectories (d+"/*"))
		)
		for d in dir_array do (
			for f in (getFiles (d + "*.*")) do (
				deleteFile f
			)
		)
		deleteFile "AShimScripts.mcr"
	)
)

createDialog AShim_rollout_setup width:200